//https://developers.google.com/maps/documentation/javascript/tutorial

// Global variables {{{1

// HTML elements
var placesmenust = document.getElementById('placesmenu').style;
var popplaces = document.getElementById('popplaces');
var elevchart = document.getElementById('elevation_chart');
var infodiv = document.getElementById('info');
var slidermaxaccuracy = document.getElementById("accuracy");
var slidermaxaccuracytext = document.getElementById("accura");
var slidermindistance = document.getElementById("mindistr");
var slidermindistancetext = document.getElementById("mindist");
var savenew = document.getElementById("savenew");
var panel = document.getElementById("panel");
var spinner = document.getElementById('spinner');

var doubleClicked = false;
var map;
var oms;
var markerBounds = new google.maps.LatLngBounds();
var initCenter = new google.maps.LatLng(-22.95357,-43.197960);
var initZoom = 14;
var chart;
var GeoMarker = null;
var infoWindow = new google.maps.InfoWindow();
var veltransito = 2.5; // Estimativa: 2.5 m/s
var here = new google.maps.LatLng();
var update_timeout = null;
var lastfile;
var lastfilePlaces = "";
var myplacesChanged = false;
var clickedMarker;
var dragMyPlaces = false;

var birdicon = "guara_24.png";
var birdiconspider = "guara_24-pink.png";
var placeicon = {url: "star_16.png", anchor: new google.maps.Point(8, 8)};
var mousemarker = null;
var iteratortrack = 0;
var iteratorbirds = 0;
var followme = true;
var isMobile = true;
var birdmarkers = [];
var birdinterpolator = 0;
var birds = [];
var birdstimes = [];
var showbirds = true;
var ignoredrecords = 0;

var showtrack = true;
var totdistance = 0;
var meanspeed = 1;
var minspeed;
var maxspeed;
var mindistance = 1;
var maxaccuracy = 24;
var showspeed;
var allMyNewPlaces = [];
var trackfile;
var trackmarks = [];
var tracktimes = [];
var trackaltis = [];
var trackaccur = [];
var myplaces = [];
var minaltis = 40000;
var maxaltis = -10000;
var track = [];
var trackindexes = [];
var trackindexspeeds = [];
var trackdistances = [];
var trackinfo;
var defaulttrackcolor = '#FFFF00'
var isOnline = false;

/*
// Precisa de spin.js: https://davidwalsh.name/demo/spin-js.php
var spinner = new Spinner({
  lines: 10, // The number of lines to draw
  length: 3, // The length of each line
  width: 5, // The line thickness
  radius: 3, // The radius of the inner circle
  color: '#FF0', // #rbg or #rrggbb
  speed: 1.4, // Rounds per second
  trail: 100, // Afterglow percentage
  shadow: false // Whether to render a shadow
});
*/
// }}}1

// Init
function initialize() { //{{{1
  // Options: https://developers.google.com/maps/documentation/javascript/reference#MapOptions

  isMobile = /AveWebview/.test(navigator.userAgent);
  if (!isMobile) {
      panel.style.visibility = "visible";
      document.getElementById('inputfile').style.display = 'inline';
      placesmenust.top = '125px';
      placesmenust.paddingRight = '5px';
      placesmenust.maxHeight = '80%';
      isOnline = navigator.onLine;
      document.getElementById('togglelabels').style.visibility = 'visible';
  } else {
    // Test if connected to internet
        var xhr = new XMLHttpRequest();
        //var url = "https://www.google.com/?rand=" + new Date().getTime();
        var url = "https://www.wikipedia.org/?rand=" + new Date().getTime();
        //xhr.timeout = 5000;
        xhr.withCredentials = false;
        xhr.open("HEAD",url,false);
        xhr.onreadystatechange = function () {
      if(xhr.readyState === XMLHttpRequest.DONE && xhr.status === 200) {
        isOnline = true;
        document.getElementById('togglelabels').style.visibility = 'visible';
      }
    }
    try {
            xhr.send();
        } catch (error) {
            isOnline = false;
            console.log("############# CONNECTION ERROR "+error);
        }
        /* Synchronous:
        try {

            isOnline = ( xhr.status >= 200 && (xhr.status < 300 || xhr.status === 304) );
            console.log("############# "+xhr.status+" - "+isOnline);
        } catch (error) {
            isOnline = false;
            console.log("############# CONNECTION ERROR "+error);
        }
        */
  }

  // URL parameters
  followme = urlParam('followme');
  trackfile = urlParam('track');

  var mapOptions = {
    scaleControl: true,
    rotateControl: true,
    disableDefaultUI: true,
    draggable: true,
    center: initCenter,
    zoom: initZoom,
    disableDoubleClickZoom: true,
    //styles: [{featureType: "poi", stylers: [{visibility: "off"}]}], // No propaganda
    //mapTypeId: google.maps.MapTypeId.HYBRID, // La propaganda atrapalha el cache??
    mapTypeId: google.maps.MapTypeId.SATELLITE,
    zIndex: -1
  };

  map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
  // https://github.com/jawj/OverlappingMarkerSpiderfier
  oms = new OverlappingMarkerSpiderfier(map,
        {markersWontMove: true, markersWontHide: true, keepSpiderfied: true});
  oms.addListener('click', function(marker) {
    openInfoWindow(marker);
  });

  // For OpenStreetMaps (OSM) instead of Google Maps:
  // Just use "'OSM'" in mapOptions mapTypeId, and replace the server Thunderforest below with something working.
  map.mapTypes.set("OSM", new google.maps.ImageMapType({
      getTileUrl: function(coord, zoom) {
        var tilesPerGlobe = 1 << zoom;
        var x = coord.x % tilesPerGlobe;
        if (x < 0) x = tilesPerGlobe+x;
        return "https://tile.thunderforest.com/transport/" + zoom + "/" + x + "/" + coord.y + ".png?apikey=c3736c9d39664765b35592bd3c7b4499";
      },
      tileSize: new google.maps.Size(256, 256),
      minZoom: 11,
      maxZoom: 16
  }));

  google.maps.event.addListener(map, 'dblclick', function(e) { newMyPlace(e.latLng); });
  //if (isMobile) google.maps.event.addListener(map, 'dragend', function() { getMapCenterZoom(); });

  // THIS DOES NOT WORK IN ANDROID: after a longclick, the timer is not cleared. See here:
  // https://stackoverflow.com/a/7560338/1483390
  /*
  var timer, timePressed = 0;
  popplaces.addEventListener('mousedown', function(e){
    timePressed = 0;
    timer = setInterval(function(){
        timePressed += 100;
        if (timePressed > 999) {
          unpopplaces();
          clearInterval(timer);
        }
    }, 100);
  });
  popplaces.addEventListener('mouseup', function(e){
    clearInterval(timer);
    if (timePressed < 300) {
      // TODO: SAVE
    }
  });
  */

  var timePressed = 0;
  var timerStop = false;
  function CheckProgress() {
    if(timerStop) {
      timePressed = 0;
      return;
    }
    if (timePressed > 799) {
      //console.log("################## LOOOOOOOOOOONG");
      unpopplaces();
      timerStop = true;
      timePressed = 0;
      return;
    }
    timePressed += 100;
    //console.log("################## "+timePressed);
    window.setTimeout(CheckProgress, 100);

  }
  popplaces.addEventListener('mousedown', function(e){ timerStop = false; CheckProgress(); });
  popplaces.addEventListener('touchstart', function(e){ timerStop = false; CheckProgress(); });
  // El if no funca!
  //if (isMobile) {
    function SaveMarkersToFile(file,str) {
      //window.open('data:text/csv;charset=utf-8,' + str); // OLD, does not work anymore
      var downloadLink = document.createElement("a");
      downloadLink.href = 'data:text/csv;charset=utf-8,' + str;
      downloadLink.download = file;
      document.body.appendChild(downloadLink);
      downloadLink.click();
      document.body.removeChild(downloadLink);
    }
    popplaces.addEventListener('touchend', function(e){
      if (isMobile && myplacesChanged && !timerStop && timePressed > 100 && timePressed < 500) {
        AndroidFunction.saveNewData(allPlacesToString(),getLastFilePlaces(),false,allMyNewPlaces.length+myplaces.length,false);
        // Esto asume que uno clico en OK!!!
        myplacesChanged = false;
      }
      timerStop = true;
    });
  //} else {
    popplaces.addEventListener('mouseup', function(e){
      if (!isMobile && myplacesChanged && !timerStop && timePressed < 300 && confirm("Save landmarks?"))
          SaveMarkersToFile(getLastFilePlaces(),encodeURI(allPlacesToString()));
      timerStop = true;
    });
  //}

  if (trackfile && trackfile.length > 0) loadThing(trackfile);
}
// How to pass js parameter to URL
function urlParam (name, w){
  w = w || window;
  var rx = new RegExp('[\&|\?]'+name+'=([^\&\#]+)'),
  val = w.location.search.match(rx);
  return ! val ? '':val[1];
}
//}}}1

// File handling functions: Android
function loadThing(file) { //{{{1
  var contentType = 'application/x-www-form-urlencoded; charset=utf-8';
  var xmlHttp = new XMLHttpRequest();
  xmlHttp.open("GET", file, true);
  xmlHttp.setRequestHeader('Content-type', contentType);
  xmlHttp.addEventListener("load", ajaxCallback, false);
  xmlHttp.send(null);
  lastfile = file;
}
function ajaxCallback(event){
  var csv = event.target.responseText;
  if (!csv || csv.length == 0) {
    printinfo("Failed to retrieve data");
    lastfile = "";
  } else
    processData(csv);
}
//}}}1
// File handling functions: Non Android
function handleFiles(files) { //{{{1
  // Check for the various File API support.
  if (window.FileReader) {
    // FileReader are supported.
    getAsText(files[0]);
  } else {
    alert('FileReader are not supported in this browser.');
  }
}
function getAsText(fileToRead) {
  lastfile = fileToRead.name;
  var reader = new FileReader();
  // Read file into memory
  reader.readAsText(fileToRead, "utf-8");
  // Handle errors load
  reader.onload = loadHandler;
  reader.onerror = errorHandler;
}
function errorHandler(evt) {
  if(evt.target.error.name == "NotReadableError") {
    alert("Cannot read file !");
  }
}
function loadHandler(event) {
  var csv = event.target.result;
  if (!csv || csv.length == 0) {
    printinfo("Failed to retrieve data");
  } else
    processData(csv);
}
//}}}1
function processData(csv) { //{{{1
  var al;
  var pt;
  var allTextLines = csv.split(/\r\n|\n/);
  var headers = allTextLines[0].split(',');
  var ti = headers.indexOf("time");
  var lo = headers.indexOf("longitude");
  var la = headers.indexOf("latitude");
  var ai = headers.indexOf("altitude");
  var sp = headers.indexOf("species");
  var sx = headers.indexOf("sex");
  var ag = headers.indexOf("age");
  var ac = headers.indexOf("activity");
  var di = headers.indexOf("records");
  var nu = headers.indexOf("number");
  var rk = headers.indexOf("remarks");
  var sd = headers.indexOf("speed");
  var ay = headers.indexOf("accuracy");
  var pl = headers.indexOf("place");
  if (pl >= 0) {
    // It's a myplace file  {{{2
    lastfilePlaces = lastfile;
    var place, titshown;
    var placemarker;
    for (var i=1; i < allTextLines.length - 1; i++) {
      place = allTextLines[i].split(',');
      if (isNotValid(place)) continue;
      pt = new google.maps.LatLng(place[la],place[lo]);
      titshown = place[pl];
      if (place.length >=5 && place[rk].length>0) titshown = titshown + "\n" + place[rk];
      if (place.length >=4 && place[ai] != 0) titshown = titshown + "\nAltitude: " + place[ai] + " mts";
      if (!isMobile) {
        try {
          // UTF8 to Latin1
          titshown = decodeURIComponent(encodeURI(titshown));
          // Latin1 to UTF8
          //titshown = unescape(encodeURIComponent(titshown));
        } catch(e) {
          //console.log("############# Encoding error")
        }
      }
      placemarker = new google.maps.Marker({
        position: pt,
        title: titshown,
        map: map,
        draggable: (dragMyPlaces),
        icon: placeicon,
        zIndex: 9000
      });
      myplaces.push(placemarker);
      markerBounds.extend(placemarker.position);

      google.maps.event.addListener(placemarker, 'dblclick', function(e) {
            doubleClicked = true;
            clearTimeout(update_timeout);
            update_timeout = null;
            myplaces.splice(myplaces.indexOf(this),1);
            this.setMap(null);
            myplacesChanged = true;
            populatePlacesMenu();
          });
      google.maps.event.addListener(placemarker, 'click', function(e) {
            clickedMarker = this;
            update_timeout = setTimeout(function(){
              if (!doubleClicked) {
                openInfoWindow(clickedMarker);
              }
              doubleClicked = false;
            }, 300);
          });
      google.maps.event.addListener(placemarker, 'dragend', function() { myplacesChanged = true; });
    }
    if (allTextLines.length > 1 && markerBounds && !markerBounds.isEmpty())
      map.fitBounds(markerBounds);
    populatePlacesMenu();
    //}}}2
  } else if (sp >= 0) {
    // It's a records file  {{{2
    var ign = 0;
    var newbirds = [];
    var newbirdsdata = [];
    var registro;
    var hora;
    for (var i=1; i < allTextLines.length; i++) {
      registro = allTextLines[i].split(',');
      if (isNotValid(registro)) continue;
      // Use bird GPS coordinates if available
      if (registro[la] != 0 || registro[la] != 0) {
        pt = new google.maps.LatLng(registro[la],registro[lo]);
        al = parseFloat(registro[ai]);
      } else {
        if (trackmarks && trackmarks.length > 0) {
          // No GPS: use the Track times  {{{3
          //console.log("No GPS data for record " + i + ": using track data");
          hora = registro[ti];
          if (hora.localeCompare(tracktimes[tracktimes.length-1]) > -1) {
            //console.log("Warning " + i + ": " + hora + " >= " + tracktimes[tracktimes.length-1]);
            pt = trackmarks[trackmarks.length-1];
            al = trackaltis[trackmarks.length-1];
          } else {
            if (hora.localeCompare(tracktimes[0]) < 1) {
              //console.log("Warning " + i + ": " + hora + " <= " + tracktimes[0]);
              pt = trackmarks[0];
              al = trackaltis[0];
            } else {
              for (var j = birdinterpolator; j < trackmarks.length; j++) {
                if (hora.localeCompare(tracktimes[j]) > 0) continue;
                birdinterpolator = j;
                break;
              }
              pt = trackmarks[birdinterpolator];
              al = trackaltis[birdinterpolator];
            }
          }
          //}}}3
        } else {
          ign++;
          if (ign <= 4) {
            emsg = "No GPS data for record #" + i + "\n   and no track loaded.\n      Ignoring record.";
            if (ign == 4) emsg = emsg + "\n==>  NO MORE WARNINGS  <==";
            alert(emsg);
          }
          continue;
        }
      }
      newbirds.push(pt);
      // Title tooltip for the birds
      // OJO: registro[sp] en ISO-8859-1!!
      var msg = registro[sp] + "\nTime: " + registro[ti] + "\nElevation: " + al + " mts";
      if (registro[sx].length > 0) msg = msg + "\nSex: " + registro[sx];
      if (registro[ag].length > 0) msg = msg + "\nAge: " + registro[ag];
      if (registro[ac].length > 0) msg = msg + "\nActivity: " + registro[ac];
      if (registro[di] && registro[di].length > 0) msg = msg + "\nRecords: " + registro[di];
      if (registro[nu].length > 0 && registro[nu] != 1) msg = msg + "\nGroup size: " + registro[nu];
      if (registro[rk].length > 2) msg = msg + "\nRemarks: " + registro[rk];
      newbirdsdata.push(msg);
    }
    // TODO: cargar mas datos
    fitmap(newbirds);
    dropbirds(newbirds, newbirdsdata, ign);
    birds.push.apply(birds, newbirds);
    birdinterpolator = 0;
    //}}}2
  } else {
    // It's a Track file  {{{2
    //Cleaning first
    iteratortrack = 0;
    totdistance = 0;
    meanspeed = 1;
    minspeed = 10000;
    maxspeed = 0;
    minaltis = 10000;
    maxaltis = -10000;
    showspeed = false;
    trackmarks = [];
    tracktimes = [];
    trackaltis = [];
    trackaccur = [];
    track = [];
    trackindexes = [];
    trackdistances = [];
    var data
    for (var i=1; i<allTextLines.length; i++) {
      data = allTextLines[i].split(',');
      al = parseFloat(data[ai]);
      // Discard non coordinate lines (EOF, etc)
      if (isNotValid(data)) continue;
      trackmarks.push(new google.maps.LatLng(data[la],data[lo]));
      tracktimes.push(data[ti]);
      if (al > maxaltis) maxaltis = al;
      if (al < minaltis) minaltis = al;
      trackaltis.push(al);
      trackaccur.push(parseInt(data[ay],10));
    }
    // reset
    mindistance = 1;
    maxaccuracy = 24;
    slidermindistancetext.innerHTML = mindistance;
    slidermindistance.value = mindistance;
    slidermaxaccuracytext.innerHTML = maxaccuracy;
    slidermaxaccuracy.value = maxaccuracy;

    fitmap(trackmarks);
    buildtrack();
    // Definitivamente no es necesario para el Desktop, y tiene bugs (no carga a veces)
    // Pero tal vez sea necesario para Android.
    //google.maps.event.addListenerOnce(map, 'idle', function(){ droptrack(); });
    droptrack();
    //}}}2
  }
}
function isNotValid(point) {
  return (!point || !point[0] || point[0].length == 0 || isNaN(point[2]) || isNaN(point[1]));

}
// }}}1

// Android ViewMap interfaces
function loadtrackfile(file) { //{{{1
  if (!file || file === "") return;
  followme = false;
  trackfile = file;
  loadThing(file);
}
function gpsgoto(GOTO) {
  var all = GOTO.split("###");
  var gps = new google.maps.Marker({
    position: {lat: parseFloat(all[0]), lng: parseFloat(all[1])},
    title: all[2]+"###"+all[3],
    map: map
  });

  google.maps.event.addListener(gps, 'click', function() {
    infoWindow.setContent("<img src='file://"+this.title.split("###")[1]+"'><center>"+this.title.split("###")[0]+"</center>");
    infoWindow.open(map,this);
  });

  map.panTo(gps.getPosition());
}
function toggleGeoLocation() { //{{{1
  // Mostrar la localizacion: Si comentada, COMENTAR TAMBIEN EL SCRIPT
  //    DEL map.html, y la seccion correspondiente del ViewMap.java
  if (!GeoMarker) {
    GeoMarker = new GeolocationMarker(map);
    google.maps.event.addListenerOnce(GeoMarker, "position_changed", function() {
      here = GeoMarker.getPosition();
      document.getElementById('me').style.visibility = 'visible';
      // This one follows my position: consumes 15% of CPU in a Galaxy Note
      // if we use addListener instead of addListenerOnce !!!
      if (followme) {
        CenterOnMe();
      }
    });
  } else {
    GeoMarker.setMap(null);
    GeoMarker = null;
  }
}
function CenterOnMe() {
  var loc = GeoMarker.getPosition();
  if (loc && map) map.panTo(loc);
}
function getMapCenterZoom() {
  if (isMobile && map) {
    var msg = map.getCenter().lat().toFixed(6) + "," + map.getCenter().lng().toFixed(6) + "," + map.getZoom();
    AndroidFunction.saveMapData(msg);
  }
}
function setMapCenterZoom(lat,lng,zoom) {
  initCenter = new google.maps.LatLng(lat,lng);
  initZoom = zoom;
  if (map) {
    map.setZoom(initZoom);
    map.setCenter(initCenter);
  }
}
function getAllPlaces() {
  if (myplacesChanged) {
    AndroidFunction.saveNewData(allPlacesToString(),getLastFilePlaces(),false,allMyNewPlaces.length+myplaces.length,true);
  } else
    AndroidFunction.saveNewData(null,null,null,null,null); // Just to quit
}
function getLastFilePlaces() {
  if (lastfilePlaces === "") {
    var now = new Date();
    var nowloc = new Date( now.getTime() - (now.getTimezoneOffset() * 60000));
    lastfilePlaces = "marks_" + nowloc.toISOString().slice(2,19).replace(/-|:/g,"").replace("T","_") + ".csv";
  }
  return lastfilePlaces;
}
//}}}1

// Showing data
function buildtrack() { //{{{1
  if (trackmarks.length == 0) return;
  var distance = 0.0;
  var accuracy = 96;
  var iant = 0;
  var speed;
  minspeed = 10000;
  maxspeed = 0;
  showspeed = false;
  trackindexspeeds = []
  trackdistances = [];
  trackindexes = [0];
  totdistance = 0;

  // Compute trackmarks subsequence indexes using mindistance and maxaccuracy
  for (var i = 1; i < trackmarks.length; i++) {
    iant = trackindexes[trackindexes.length-1];
    distance = dist(trackmarks[iant],trackmarks[i]);
    if (i != trackmarks.length-1 && (distance < mindistance || trackaccur[i] > maxaccuracy)) continue;
    trackindexes.push(i);
    totdistance = totdistance + distance;
    trackdistances.push(distance);
    //if (distance > 100)
    //  alert(distance+": "+iant+" "+i+"\n"+trackmarks[iant]+"\n"+trackmarks[i]);
  }

  if (showtrack) poptrack();
  // Build new track subsequence
  track = [];
  for (var j = 0; j < trackindexes.length-1; j++) {
    speed = computespeed(j);
    if (speed < minspeed) minspeed = speed;
    if (speed > maxspeed) maxspeed = speed;
    trackindexspeeds.push(speed); // Store partial speeds of subsequences
    track.push(new google.maps.Polyline({
      path: [trackmarks[trackindexes[j]],trackmarks[trackindexes[j+1]]],
      strokeColor: defaulttrackcolor,
      strokeOpacity: 1.0,
      zIndex: 9990,
      strokeWeight: 3
     })
    );
  }

  meanspeed = totdistance/deltime(tracktimes[0],tracktimes[tracktimes.length-1]);

  // info
  trackinfo = "Total distance: " + Math.round(totdistance) + "m"
     + "<br>Mean speed: " + Math.round(100*meanspeed)/100 + "m/s"
     + "<br>Max speed: " + Math.round(100*maxspeed)/100 + "m/s"
     + "<br>Min Elevation: " + minaltis + "m"
     + "<br>Max Elevation: " + maxaltis + "m"
     + "<br>Number of marks: " + trackindexes.length;
}
//}}}1
function droptrack() { //{{{1
  printinfo(trackinfo);
  showtrack = true;
  iteratortrack = 0;
  var len = track.length;
  var duration = 4000;
  var init = new google.maps.Marker({
    position: track[0].getPath().getArray()[0],
    map: map,
    zIndex: 9999,
    icon: "green-dot.png"
  });
  var ti = trackinfo;
  var fi = lastfile.replace(/.csv$/,'').replace(/^.*[\\\/]/, '');
  google.maps.event.addListener(init, 'click', function() {
    infoWindow.setContent(fi+"<br>"+ti);
    infoWindow.open(map,this);
  });
  for (var i = 0; i < len; i++) {
    setTimeout(function() {
      addline();
    }, i * duration/len);
  }
  setTimeout(function() {
    panel.style.visibility = "visible";
    document.getElementById("tracks").style.visibility = "visible";
  }, duration);
}
function addline() {
  track[iteratortrack].setMap(map);
  iteratortrack++;
  // After adding track, add records
  if (iteratortrack == track.length-1) {
    setTimeout(function() {
      plotelevation();
      if (trackfile && trackfile.length > 4) {
        trackfile = trackfile.replace(".csv","_REG.csv");
        loadThing(trackfile);
        loadThing(trackfile.replace("_REG.csv","_MARKS.csv"));
      }
    }, 250);
  }
}
function poptrack() { //{{{1
  var len = track.length;
  if (len == 0) return;
  if (showtrack) {
    for (var j = 0; j < track.length; j++) {
      track[j].setMap(null);
    }
    printinfo("");
    elevchart.style.visibility = 'hidden';
    if (isMobile) map.setZoom(map.getZoom()-1); // Tentativa de corregir lixo sobrante
  } else {
    if (isMobile) fit();                        // Tentativa de corregir lixo sobrante
    for (var j = 0; j < track.length; j++) {
      track[j].setMap(map);
    }
    printinfo(trackinfo);
    elevchart.style.visibility = 'visible';
  }
  showtrack = !showtrack;
}
//}}}1
function plotelevation() { //{{{1
  // Only works in android >= 3
  var ua = ua || navigator.userAgent;
  var match = ua.match(/Android\s([0-9\.]*)/);
  if (match && parseInt(match[1]) < 3) return;

  elevchart.style.visibility = 'visible';
    var option = {
      legend: 'none',
      height: 94,
      width: 200,
      curveType:'function',
      lineWidth: 2,
      colors: ["#BBBB00"],
      chartArea: {left: 35, width: 160, height: 80 },
      vAxis: {
        format: '####',
        gridlines: { color: '#AAA', count: 8 },
        textStyle: { color: '#CCC', bold: true, fontSize: 10 },
        baselineColor: 'red',
      },
    backgroundColor: 'transparent',
    intervals: { 'style': 'line' },
    focusTarget: 'category',
    tooltip: { trigger: 'none' },
    dataOpacity: 0.7,
  }
  // Build data
  var data = new google.visualization.DataTable();
  data.addColumn('string', 'Sample');
  data.addColumn('number', 'Elevation (m):');
  for (var i = 0; i < trackmarks.length; i++) {
    data.addRow(['', trackaltis[i]]);
  }

  // Draw the chart using the data within its DIV.
  chart = new google.visualization.LineChart(elevchart);
  chart.draw(data, option);

  // Listeners
  google.visualization.events.addListener(chart, 'onmouseover', function(e) {
    var j = e.row;
    if (!mousemarker) {
      mousemarker = new google.maps.Marker({
        position: trackmarks[j],
        map: map,
        zIndex: 9999,
        icon: "green-dot.png"
      });
    } else {
      mousemarker.setPosition(trackmarks[e.row]);
    }
    var s = Math.round(computespeedori(j)*100)/100;
    printinfo("Time: " + tracktimes[j] + "<br>Elevation: " + trackaltis[j] + " m<br>Speed: " + s + " m/s" + "<br>Accuracy: " + trackaccur[j]);
  });
}
function clearMouseMarker() {
  if (mousemarker) {
    mousemarker.setMap(null);
    mousemarker = null;
  }
  printinfo(trackinfo);
}
//}}}1
function togglespeed() { //{{{1
  var speed = 3;
  showspeed = !showspeed;
  if (showtrack) poptrack();
  if (showspeed) {
    for (var j = 0; j < track.length; j++) {
      track[j].setOptions({strokeColor: speedtocolor(trackindexspeeds[j])});
    }
  } else {
    for (var j = 0; j < track.length; j++) {
      track[j].setOptions({strokeColor: defaulttrackcolor});
    }
  }
  poptrack();
}
function speedtocolor(s) {
  var valor = Math.floor(255*(1-square((maxspeed - s)/(minspeed-maxspeed)))).toString(16);
  return "#ff" + valor + "00";
}
function computespeedori(j) {
  if (j < 0 || j > trackmarks.length-2) return 0;
  var d = dist(trackmarks[j],trackmarks[j+1]);
  return d/deltime(tracktimes[j],tracktimes[j+1]);
}
function computespeed(j) {
  if (j < 0 || j > trackindexes.length-2) return 0;
  return trackdistances[j]/deltime(tracktimes[trackindexes[j]],tracktimes[trackindexes[j+1]]);
}
function togglelabels() { //{{{1
  var id = "hybrid";
  if (map.getMapTypeId() == "hybrid") id = "satellite";
  map.setMapTypeId(id);
}
function openInfoWindow(m) {
  infoWindow.setContent(m.get("title").replace(/, |\r\n|\n|\//g, '<br>'));
  infoWindow.open(map,m);
}
//}}}1

function dropbirds(blist,bdata,ign) { //{{{1
  var len = blist.length;
  var duration = 3000; // in miliseconds
  var msg = len + " record"+((len>1)?"s":"")+" added";
  if (ign>0) {
    msg = msg+"<br>"+ign+" record"+((ign>1)?"s":"")+" ignored";
    ignoredrecords = ignoredrecords + ign;
  }
  printinfo(msg);
  iteratorbirds = 0;
  for (var i = 0; i < len; i++) {
    setTimeout(function() {
      addBirdMarker(blist,bdata);
    }, (i * duration)/len);
  }
  setTimeout(function() {
    panel.style.visibility = "visible";
    document.getElementById("records").style.visibility = "visible";
  }, duration);
      oms.addListener('spiderfy', function(birdmarkers) {
        for(var i = 0; i < birdmarkers.length; i ++) {
          birdmarkers[i].setIcon(birdiconspider);
        }
        infoWindow.close();
      });
      oms.addListener('unspiderfy', function(birdmarkers) {
        for(var i = 0; i < birdmarkers.length; i ++) {
          birdmarkers[i].setIcon(birdicon);
        }
      });
}
function addBirdMarker(brd,dat) {
  var marker = new google.maps.Marker({
    position: brd[iteratorbirds],
    title: dat[iteratorbirds],
    map: map,
    draggable: false,
    icon: birdicon,
    zIndex: 9000
    //animation: google.maps.Animation.DROP
  });
  birdmarkers.push(marker);
  oms.addMarker(marker);

  // On Click listener: info (reemplazado por el oms)
  /*
  google.maps.event.addListener(marker, 'click', function() {
    var m = this.get("title").replace(/, |\r\n|\n/g, '<br>');
    infoWindow.setContent(m);
    infoWindow.open(map,this);
  });
  */
  iteratorbirds++;
}
function popbirds() { //{{{1
  var len = birdmarkers.length;
  if (len == 0) return;
  var msg = "";
  if (showbirds) {
    for (var i = 0; i < len; i++) {
      birdmarkers[i].setMap(null);
    }
  } else {
    msg = len + " record"+((len>1)?"s":"");
    if (ignoredrecords>0)
      msg = msg+"<br>"+ignoredrecords+" record"+((ignoredrecords>1)?"s":"")+" ignored";
    for (var i = 0; i < len; i++) {
      birdmarkers[i].setMap(map);
    }
  }
  printinfo(msg);
  showbirds = !showbirds;
}
//}}}1

// Landmarks - places
function showMarkerInfo(n) { //{{{1
  var marker = ((n < myplaces.length) ? myplaces[n] : allMyNewPlaces[n - myplaces.length]);
  map.panTo(marker.getPosition());
  openInfoWindow(marker);
}
function populatePlacesMenu() {
  var tit, ih = "";
  for (var i = 0; i < myplaces.length; i++) {
    tit = myplaces[i].title.replace(/[\n\/].*/g,"");
    ih = ih + "<li onclick='showMarkerInfo("+i+")'>"+tit+"</li>";
  }
  for (i = 0; i < allMyNewPlaces.length; i++) {
    tit = allMyNewPlaces[i].title.replace(/[\n\/].*/g,"");
    ih = ih + "<li onclick='showMarkerInfo("+(i+myplaces.length)+")'><b>"+tit+"</b></li>";
  }
  document.getElementById('placesul').innerHTML = ih;
  if (isMobile && panel.style.visibility === 'visible') {
    placesmenust.top = '100px';
    placesmenust.maxHeight = '40%';
  }
  popplaces.style.visibility = 'visible';
}
function unpopplaces() { //{{{1
  document.getElementById('placesul').innerHTML = "";
  for (var j = 0; j < myplaces.length; j++) {
    google.maps.event.clearInstanceListeners(myplaces[j]);
    myplaces[j].setMap(null);
  }
  for (j = 0; j < allMyNewPlaces.length; j++) {
    google.maps.event.clearInstanceListeners(allMyNewPlaces[j]);
    allMyNewPlaces[j].setMap(null);
  }
  myplaces = [];
  allMyNewPlaces = [];
  myplacesChanged = false;
  markerBounds = new google.maps.LatLngBounds();
  printinfo("");
  popplaces.style.visibility = 'hidden';
  dragMyPlaces = false;
}
function newMyPlace(position) { //{{{1
  infoWindow.close();
  var altitude = "";
  //var ttt = "   Coord: ("+parseFloat(position.lat().toFixed(6))+","+parseFloat(position.lng().toFixed(6))+")\n\nEnter new mark (description[/remark]):";
  var ttt = "   Coord: ("+niceCoord(new google.maps.Marker({position: position}))+")\n\nEnter new mark (description[/remark]):";
  if (isOnline) {
    var spinnerID = setTimeout(function() { spinner.style.display = "block"; }, 300);
    var elevator = new google.maps.ElevationService;
    elevator.getElevationForLocations({ 'locations': [position] },
      function(results, status) {
        clearTimeout(spinnerID);
        spinner.style.display = "none";
        if (status === 'OK' && results[0]) {
          altitude = results[0].elevation.toFixed(0);
          ttt = "   Altitude: " + altitude + " meters\n\n" + ttt;
        } else {
          ttt = "   Altitude: Service failed ("+status+")\n\n"+ttt;
        }

        actualNewMyPlace(position,ttt,altitude);
      });
  } else {
    actualNewMyPlace(position,ttt,altitude);
  }
}
function actualNewMyPlace(position,ttt,altitude) {
  var tit = prompt(ttt,'');
  if (tit && tit.indexOf("/") != 0) {
    if (altitude != "")
      tit = tit.replace("/","\n") + "\nAltitude: " + altitude + " mts";
    var marker = new google.maps.Marker({
      title: tit,
      label: '*',
      draggable: true,
      raiseOnDrag: true,
      icon: placeicon,
      animation: google.maps.Animation.DROP,
      position: position,
      map: map
    });
    google.maps.event.addListener(marker, 'dblclick', function(e) {
      doubleClicked = true;
      clearTimeout(update_timeout);
      update_timeout = null;
      allMyNewPlaces.splice(allMyNewPlaces.indexOf(marker),1);
      marker.setMap(null);
      myplacesChanged = true;
      populatePlacesMenu();
    });
    google.maps.event.addListener(marker, 'click', function(e) {
      update_timeout = setTimeout(function(){
        if (!doubleClicked) {
          var oldtit, newtit, it;
          oldtit = marker.get("title");
          newtit = oldtit;
          if (oldtit.match(/Altitude:(.*)/))
            newtit = oldtit.substring(0,oldtit.indexOf("\nAltitude:"));
          newtit = newtit.split("\n").join("/");
          ti = prompt("Set marker title", newtit);
          if (ti != null && ti.length > 0) {
            ti = ti.replace("/","\n");
            if (oldtit.match(/Altitude:(.*)/))
              ti = ti + "\n" + oldtit.substring(oldtit.indexOf("Altitude:"));
            marker.setTitle(ti);
            myplacesChanged = true;
            populatePlacesMenu();
          }
        }
        doubleClicked = false;
      }, 300);
    });
    google.maps.event.addListener(marker, 'dragend', function() {
      getNewAltitude(this);
    });

    allMyNewPlaces.push(marker);
    markerBounds.extend(marker.position);
    if (allMyNewPlaces.length > 1) map.fitBounds(markerBounds);
    myplacesChanged = true;
    populatePlacesMenu();
  }
  // Allow dragging of myplaces[]:
  if (!dragMyPlaces) {
    dragMyPlaces = true;
    for (var i=0; i<myplaces.length; i++) {
      myplaces[i].setOptions({draggable: true});
      google.maps.event.addListener(myplaces[i], 'dragend', function() {
        getNewAltitude(this);
      });
    }
  }
}
function getNewAltitude(m) {
  myplacesChanged = true;
  var tit = m.get("title");
  if (tit.match(/Altitude: *([-0-9]*) *mts/))
    tit = tit.substring(0,tit.indexOf("\nAltitude:"));
  if (isOnline) {
    var spinnerID = setTimeout(function() { spinner.style.display = "block"; }, 300);
    var elevator = new google.maps.ElevationService;
    elevator.getElevationForLocations({ 'locations': [m.position] },
      function(results, status) {
        clearTimeout(spinnerID);
        spinner.style.display = "none";
        if (status === 'OK' && results[0]) {
          altitude = results[0].elevation.toFixed(0);
          tit = tit+"\nAltitude: " + altitude + " mts";
        }
        m.setTitle(tit);
        openInfoWindow(m);
      });
  } else {
    m.setTitle(tit);
    openInfoWindow(m);
  }
}
function allPlacesToString() {
    var msg = "place,latitude,longitude,altitude,remarks";
    var ind, tit, altitude, obs;
    var re = /Altitude: *([-0-9]*) *mts/;
    // Old places
    for (var i=0; i<myplaces.length; i++) {
      altitude = "", obs = "";
      tit = myplaces[i].title.split("\n");
      if (tit[1] != null) {
        if (tit[1].match(re) != null)
          altitude = tit[1].match(re)[1];
        else {
          obs = tit[1];
          if (tit[2] != null && tit[2].match(re) != null) altitude = tit[2].match(re)[1];
        }
      }
      msg = msg + "\n" + tit[0]+ "," + niceCoord(myplaces[i]) + "," + altitude + "," + obs;
    }
    // New places
    for (var i=0; i<allMyNewPlaces.length; i++) {
      altitude = "", obs = "";
      tit = allMyNewPlaces[i].title.split("\n");
      if (tit[1] != null) {
        if (tit[1].match(re) != null)
          altitude = tit[1].match(re)[1];
        else {
          obs = tit[1];
          if (tit[2] != null && tit[2].match(re) != null) altitude = tit[2].match(re)[1];
        }
      }
      msg = msg + "\n" + tit[0]+ "," + niceCoord(allMyNewPlaces[i]) + "," + altitude + "," + obs;
    }

//    for (var i=0; i<allMyNewPlaces.length; i++) {
//      altitude = "";
//      tit = allMyNewPlaces[i].title;
//      if (tit.match(re) != null) {
//        altitude = tit.match(re)[1];
//        tit = tit.substring(0,tit.indexOf("\nAltitude:"));
//      }
//      ind = tit.indexOf("/");
//      if (ind == -1) ind = 1000;
//      msg = msg + "\n" + tit.substring(0,ind) + "," + niceCoord(allMyNewPlaces[i]) + "," + altitude + "," + tit.substring(ind+1);
//    }

    return msg+"\n";
}
function niceCoord(m) {
  return parseFloat(m.position.lat().toFixed(6)) + "," + parseFloat(m.position.lng().toFixed(6));
}
//}}}1

// Time functions
function deltime(t1,t2) { //{{{1
  var del = timeinsecs(t2)-timeinsecs(t1);
  if (del < 0) del = del + 86400;
  return del; // Seconds
}
function timeinsecs(timestring) { //{{{1
  var time = timestring.split(':'); // DA ERROR UNDEFINED
  return parseInt(time[2],10) + parseInt(time[1],10)*60 + parseInt(time[0],10)*3600;
}
//}}}1

// Auxiliary functions
function ParamChanged() { //{{{1
  if (!trackmarks || trackmarks.length == 0) return;
  mindistance = slidermindistance.value;
  maxaccuracy = slidermaxaccuracy.value;
  slidermindistancetext.innerHTML = mindistance;
  slidermaxaccuracytext.innerHTML = maxaccuracy;
  savenew.style.visibility = "visible";
  buildtrack();
  poptrack();
}
function saveNew() {
  var msg = "time,longitude,latitude,altitude,speed,accuracy";
  var filet = lastfile.replace("_REG","").replace("_MARKS","").replace(".csv","-NEW.csv");
  var j;
  for (var i = 0; i < trackindexes.length; i++) {
    j = trackindexes[i];
    msg = msg + "\n" + tracktimes[j]
      + "," + niceCoord(trackmarks[j])
      + "," + trackaltis[j]
      + "," + Math.round(100*computespeed(i))/100
      + "," + trackaccur[j];
  }
  if (isMobile)
    AndroidFunction.saveNewData(msg,filet,false,i,true);
  else
    SaveMarkersToFile(filet,encodeURI(msg));
// Works in chrome
//  var link = document.createElement('a');
//  link.download = "fileName.csv";
//  link.href = 'data:,' + msg;
//  link.click();
}
// }}}1
function fitmap(marks) { //{{{1
  if (!marks) {
    alert("No data?");
    return;
  } else {
    for (var i = 0; i < marks.length; i++) {
      markerBounds.extend(marks[i]);
    }
    fit();
  }
}
function fit() {
  if (markerBounds && ! markerBounds.isEmpty()) {
    map.fitBounds(markerBounds);
    map.setZoom(Math.min(map.getZoom(),16));
  }
}
//}}}1
function printinfo(msg) { //{{{1
  if (msg && (msg.length>0 || !isNaN(msg))) {
    infodiv.style.visibility = 'visible';
    infodiv.innerHTML = msg;
  } else
    infodiv.style.visibility = 'hidden';
}
//}}}1
function dist(p,q) { //{{{1
  var c = 0.01745329252; // PI/180;
  // Google (randomly wrong results in Android!) Needs geometry library.
  //return google.maps.geometry.spherical.computeDistanceBetween(p,q);
  // Chord
  //return 9019995.5222 * Math.sqrt((1-Math.cos(c*(p.lat()-q.lat())))
  //   + (1-Math.cos(c*(p.lng()-q.lng()))) * Math.cos(c*p.lat()) * Math.cos(c*q.lat()));
  // Taylor for chord
  return 111318.845 * Math.sqrt(square(p.lat()-q.lat())
       + square(p.lng()-q.lng()) * Math.cos(c*p.lat()) * Math.cos(c*q.lat()));
}
function square(x) {
  return x*x;

}
//}}}1

google.load('visualization', '1.1', {packages: ['corechart']});
window.addEventListener('load', initialize);

window.onorientationchange = function() { setTimeout(fit, 500); };

// vim:shiftwidth=2:tabstop=2
